#include <ppltasks.h>
#include <iostream>
#include <sstream>

using namespace Concurrency;
using namespace std;

// task_status ü Ʈ  ȯ
std::wstring get_status_string(task_status status)
{
	switch (status)
	{
	case not_complete:
		return L"not_complete";

	case completed:
		return L"completed";

	case canceled:
		return L"canceled";
	}
	return L"";
}

// ۾ Լ
bool do_work()
{
	wcout << L"Performing work..." << endl;
	wait(250);
	return true;
}

int wmain()
{
	cancellation_token_source cts;

	wcout << L"Creating task..." << endl;

	// ½ũ Ͽ ۾ 
	auto t = create_task([]
	{
		bool moreToDo = true;
		while (moreToDo)
		{
			//  û   ½ũ 
			interruption_point();

			// ۾ 
			moreToDo = do_work();
		}
	}, cts.get_token());


	// 1    û
	wait(1000);

	wcout << L"Canceling task..." << endl;
	cts.cancel();

	// ½ũ ҵǾ   
	wcout << L"Waiting for task to complete..." << endl;
	task_status status = t.wait();

	// ½ũ  
	wcout << L"Done." << endl;
	wcout << L"Task status: " << get_status_string(status) << endl;
}
