#include <ppltasks.h>
#include <iostream>
#include <sstream>

using namespace Concurrency;
using namespace std;

// task_status ü Ʈ  ȯ
std::wstring get_status_string(task_status status)
{
	switch (status)
	{
	case not_complete:
		return L"not_complete";

	case completed:
		return L"completed";

	case canceled:
		return L"canceled";
	}
	return L"";
}

int wmain()
{
	//  ½ũ 
	auto t1 = create_task([]() -> int
	{
		// ½ũ 
		cancel_current_task();
	});

	//  ½ũ ½ũ  
	auto t2 = t1.then([](task<int> t)
	{	
		try
		{
			int n = t.get();
			wcout << L"The previous task returned " << n << L'.' << endl;
		}
		catch (const task_canceled&)
		{
			wcout << L"The previous task was canceled." << endl;
		}
	});

	//  ½ũ   
	task_status status = t2.wait();
	wcout << L"Task status of t2: " << get_status_string(status) << endl;
}
